/*
 * generated by Xtext 2.25.0
 */
package org.etsi.mts.tdl.formatting2;

import java.util.List;

import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.formatting2.IFormattableDocument;
import org.eclipse.xtext.formatting2.IHiddenRegionFormatter;
import org.eclipse.xtext.formatting2.regionaccess.ISemanticRegion;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;
import org.etsi.mts.tdl.Element;
import org.etsi.mts.tdl.ElementImport;
import org.etsi.mts.tdl.PackageableElement;
import org.etsi.mts.tdl.StructuredDataType;
import org.etsi.mts.tdl.StructuredDataInstance;
import org.etsi.mts.tdl.TestObjective;
import org.etsi.mts.tdl.TimeLabel;
import org.etsi.mts.tdl.tdlPackage;
import org.etsi.mts.tdl.TimeConstraint;
import org.etsi.mts.tdl.ComponentType;
import org.etsi.mts.tdl.Annotation;
import org.etsi.mts.tdl.Extension;
import org.etsi.mts.tdl.DataElementMapping;
import org.etsi.mts.tdl.TestConfiguration;
import org.etsi.mts.tdl.TestDescription;
import org.etsi.mts.tdl.Behaviour;
import org.etsi.mts.tdl.ExceptionalBehaviour;
import org.etsi.mts.tdl.PeriodicBehaviour;
import org.etsi.mts.tdl.Comment;
import org.etsi.mts.tdl.FormalParameter;
import org.etsi.mts.tdl.LocalExpression;
import org.etsi.mts.tdl.services.TDLtxiGrammarAccess;

import com.google.inject.Inject;

public class TDLtxiFormatter extends TDLtxFormatter {
	@Inject
	private TDLtxiGrammarAccess _grammarAccess;
	
	@Override protected void formatCustom(Element e, IFormattableDocument doc) {
		
	}

	protected void format(org.etsi.mts.tdl.Block e, IFormattableDocument doc) {
		for (var m : e.eContents()) {
			if (!(m instanceof Annotation) && !(m instanceof LocalExpression)) {
				//TODO: handle nested behaviour
				doc.prepend(m, p->p.newLine());
				doc.surround(m, p->p.indent());
				doc.append(m, p->p.newLine());
			} else if (m instanceof Annotation) {
				doc.append(m, p->p.newLine());
			} else {
			}
			doc.format(m);
		}
	}

	protected void format(org.etsi.mts.tdl.Element e, IFormattableDocument doc) {
		var open = this.textRegionExtensions.regionFor(e).ruleCallsTo(this._grammarAccess.getBEGINRule());
		var close = this.textRegionExtensions.regionFor(e).ruleCallsTo(this._grammarAccess.getENDRule());
		if (!open.isEmpty()) {
			doc.append(open.get(0), p->p.newLine());
			doc.interior(open.get(0), close.get(0), p->p.indent());
		}
//		doc.interior(e, p->p.indent());
		if (e instanceof Behaviour) {
//			List<ISemanticRegion> assignments = this.textRegionExtensions.regionFor(e).assignments(this._grammarAccess.findAssignments(this._grammarAccess.getTimeConstraintFragmentRule()).toArray(new Assignment[] {}));
//			for (var a : assignments) {
//				doc.prepend(a.getPreviousSemanticRegion(), p->p.newLine());
//				doc.surround(a.getPreviousSemanticRegion(), p->p.indent());
//				doc.append(a, p->p.newLine());
//			}
			List<ISemanticRegion> features = this.textRegionExtensions.regionFor(e).features(
					tdlPackage.Literals.BEHAVIOUR__TEST_OBJECTIVE
//					tdlPackage.Literals.ATOMIC_BEHAVIOUR__TIME_CONSTRAINT, 
//					tdlPackage.Literals.ATOMIC_BEHAVIOUR__TIME_LABEL 
					);
			for (var f : features) {
				//TODO: this depends on keywords..
				doc.prepend(f.getPreviousSemanticRegion(), p->p.newLine());
				doc.surround(f.getPreviousSemanticRegion(), p->p.indent());
				doc.append(f, p->p.newLine());
			}
		}

		
		
		for (var m : e.eContents()) {
			if (m instanceof TimeLabel ||
					m instanceof TimeConstraint //||
//					m instanceof Comment
					) { 
				doc.append(m, p->p.newLine());
			} else if (m instanceof Comment || 
					m instanceof TestObjective ||
					m instanceof ExceptionalBehaviour ||
					m instanceof PeriodicBehaviour
					) {
				doc.prepend(m, p->p.newLine());
				doc.surround(m, p->p.indent());
				doc.append(m, p->p.newLine());
			}
			doc.format(m);
		}
	}

	
	@Override protected void format(org.etsi.mts.tdl.NamedElement e, IFormattableDocument doc) {
		doc.surround(e, p->p.newLine());
//		doc.interior(e, p->p.indent());
//		doc.format(e);
//		doc.interior(e, p->p.indent());

		if (e instanceof StructuredDataType) {
//			var open = this.textRegionExtensions.regionFor(e).ruleCallsTo(this._grammarAccess.getBEGINRule());
//			var close = this.textRegionExtensions.regionFor(e).ruleCallsTo(this._grammarAccess.getENDRule());
//
//			doc.append(open.get(0), p->p.newLine());
//			doc.interior(open.get(0), close.get(0), p->p.indent());
			
			for (var m : ((StructuredDataType)e).getMember()) {
				doc.surround(m, p->p.indent());
				doc.append(m, p->p.newLine());
				doc.format(m);
			}
		}

		if (e instanceof StructuredDataInstance) {
			for (var m : ((StructuredDataInstance)e).getMemberAssignment()) {
				doc.prepend(m, p->p.newLine());
				doc.surround(m, p->p.indent());
				doc.append(m, p->p.newLine());
				doc.format(m);
			}
		}

		if (e instanceof ComponentType ||
				e instanceof TestConfiguration ||
				e instanceof TestDescription) {
			for (var m : e.eContents()) {
				if (!(m instanceof Annotation) && 
						!(m instanceof Extension) &&
						!(m instanceof FormalParameter)) {
					doc.prepend(m, p->p.newLine());
					doc.surround(m, p->p.indent());
					doc.append(m, p->p.newLine());
					doc.format(m);
				}
			}
		}

		if (e instanceof DataElementMapping) {
			for (var m : ((DataElementMapping)e).getParameterMapping()) {
				doc.surround(m, p->p.indent());
				doc.append(m, p->p.newLine());
				doc.format(m);
			}
		}
		
		//Test Objective Only
		if (e instanceof TestObjective) {
			ISemanticRegion dKeyword = this.textRegionExtensions.regionFor(e).keyword("Description:");
			doc.prepend(dKeyword, p->p.newLine());
			ISemanticRegion rKeyword = this.textRegionExtensions.regionFor(e).keyword("References:");
			doc.prepend(rKeyword, p->p.newLine());
		}
		//All
		ISemanticRegion withKeyword = this.textRegionExtensions.regionFor(e).keyword("With:");
		if (withKeyword!=null) {
			doc.surround(withKeyword, p->p.newLine());
			doc.append(withKeyword, p->p.indent());
//			doc.interior(
//					withKeyword.getNextHiddenRegion().getNextSemanticRegion(), 
//					this.textRegionExtensions.nextHiddenRegion(e).getNextSemanticRegion(), 
//					p->p.indent()
//					);
		}
		//doc.prepend(withKeyword, p->p.indent());
		//withKeyword.getNextSemanticRegion();
		//		var rbs = this.textRegionExtensions.regionFor(e).ruleCallTo(this._grammarAccess.());
		for (var c : e.getComment()) {
			doc.surround(c, p->p.indent());
			doc.append(c, p->p.newLine());
			doc.format(c);
		}
		
		for (var a : e.getAnnotation()) {
			doc.append(a, p->p.newLine());
			doc.format(a);
		}
		
	}

	@Override protected void format(org.etsi.mts.tdl.Package _package, IFormattableDocument doc) {
		// TODO: format HiddenRegions around keywords, attributes, cross references, etc. 
		doc.interior(_package, p->p.indent());

		var e = _package;
		var dots = this.textRegionExtensions.allRegionsFor(e).keywords(".", "@");
		for (var dot : dots) {
			doc.surround(dot, p -> p.noSpace());
		}
		for (ElementImport elementImport : _package.getImport()) {
			doc.surround(elementImport, p -> p.setNewLines(1));
			doc.format(elementImport);
		}
		for (PackageableElement packageableElement : _package.getPackagedElement()) {
			doc.surround(packageableElement, p -> p.setNewLines(1));
			doc.format(packageableElement);
		}
		for (org.etsi.mts.tdl.Package __package : _package.getNestedPackage()) {
			doc.format(__package);
		}
	}
	
}
